#include <stdio.h>
#define EPSILON 0.000001  //  
#define N 3
int main()
{
	/* 밢 ҿ  ū   ǹ   */
	float A[N][N + 1] =
	{ 2, -1, 1, -1, 3, 3, 9, 0, 3, 3, 5, 4 };

	float X[N]; /* Unknown Vector */
	int i, j, k, p;
	float m, fSum, t;

	printf("\n** Augmented Matrix A of Linear System **\n");
	for (j = 0; j < N; j++)
	{
		for (k = 0; k <= N; k++)
			printf("%f ", A[j][k]);
		printf("\n");
	}

	printf("** Gaussian Ellimination Process **\n");
	for (i = 0; i < N - 1; i++) /*   ؼ 밢   0  */
	{
		printf("\n** i = %d, for checking **\n", i);
		for (p = i; p < N; p++)
		{
			/*  if (A[p][i] != 0)  */
			if (!((-EPSILON < A[p][i]) && (A[p][i] < EPSILON)))
				break;
		}

		if (p < N)
		{
			printf("p = %d, for checking\n", p);
			if (i != p)
			{
				printf("Exchange Raw: E%d <-> E%d", i, p);
				for (k = 0; k <= N; k++)
				{
					t = A[i][k];
					A[i][k] = A[p][k];
					A[p][k] = t;
				}
			}
		}
		else
		{
			printf("No unique solution");
			return; /* exit(0) */
		}

		for (j = i + 1; j < N; j++)
		{
			m = A[j][i] / A[i][i];
			printf("m = A[%d][%d]/A[%d][%d] = %f, for checking\n", j, i, i, i, m);
			for (k = 0; k <= N; k++)
			{
				A[j][k] = A[j][k] - m * A[i][k];
			}
		}

		if (A[N - 1][N - 1] == 0)
		{
			printf("No unique solution");
			return;
		}

		printf("\n** Matrix A for checking **\n");
		for (j = 0; j < N; j++)
		{
			for (k = 0; k <= N; k++)
				printf("%f ", A[j][k]);
			printf("\n");
		}
	} /* 콺 Ұ   */

	printf("** Backward substitution Process **\n");
	X[N - 1] = A[N - 1][N] / A[N - 1][N - 1];
	for (i = N - 2; i >= 0; i--)
	{
		fSum = 0.0;
		for (j = i + 1; j < N; j++)
			fSum += A[i][j] * X[j];
		X[i] = (A[i][N] - fSum) / A[i][i];
	}

	printf("\n** Solution Vector X **\n");
	for (i = 0; i < N; i++)
	{
		printf("X[%d] = %f\n", i, X[i]);
	}

	printf("\n** Solution Check **\n");
	for (i = 0; i < N; i++)
	{
		fSum = 0;
		for (j = 0; j < N; j++)
			fSum += A[i][j] * X[j];
		fSum -= A[i][N];
		printf("E%d = %f\n", i, fSum);
	}
	return 0;
}
