#include <stdio.h>
#include <math.h>  /* fabs() */
typedef struct fcomplex {double r, i; } FCOMPLEX;
FCOMPLEX Cadd(FCOMPLEX a, FCOMPLEX b);
FCOMPLEX Csub(FCOMPLEX a, FCOMPLEX b);
FCOMPLEX Cmul(FCOMPLEX a, FCOMPLEX b);
FCOMPLEX Cdiv(FCOMPLEX a, FCOMPLEX b);
FCOMPLEX CMPLX(float r, float i);
void printCmplex(FCOMPLEX a);

int main()
{
	FCOMPLEX a, b, c, d, e, f;
	a = CMPLX(1.0, 2.0); /* 1.0 + j2.0 */
	b = CMPLX(2.0, 3.0); /* 2.0 + j3.0 */
	c = Cadd(a, b);
	d = Csub(a, b);
	e = Cmul(a, b);
	f = Cdiv(a, b);
	printCmplex(a);
	printCmplex(b);
	printCmplex(c);
	printCmplex(d);
	printCmplex(e);
	printCmplex(f);
	return 0;
}

FCOMPLEX Cadd(FCOMPLEX a, FCOMPLEX b)
{
	FCOMPLEX c;
	c.r = a.r + b.r;
	c.i = a.i + b.i;
	return c;
}

FCOMPLEX Csub(FCOMPLEX a, FCOMPLEX b)
{
	FCOMPLEX c;
	c.r = a.r - b.r;
	c.i = a.i - b.i;
	return c;
}

FCOMPLEX Cmul(FCOMPLEX a, FCOMPLEX b)
{
	FCOMPLEX c;
	c.r = a.r * b.r - a.i * b.i;
	c.i = a.i * b.r + a.r * b.i;
	return c;
}

FCOMPLEX Cdiv(FCOMPLEX a, FCOMPLEX b)
{
	FCOMPLEX c;
	double r, den;
	if (fabs(b.r) >= fabs(b.i))
	{
		r = b.i / b.r;
		den = b.r + r * b.i;
		c.r = (a.r + r * a.i) / den;
		c.i = (a.i - r * a.r) / den;
	}
	else
	{
		r = b.r / b.i;
		den = b.i + r * b.r;
		c.r = (a.r * r + a.i) / den;
		c.i = (a.i * r - a.r) / den;
	}
	return c;
}

FCOMPLEX CMPLX(float r, float i)
{
	FCOMPLEX c;
	c.r = r;
	c.i = i;
	return c;
}

void printCmplex(FCOMPLEX a)
{
	printf("%f + %fj\n", a.r, a.i);
}
