#include <stdio.h>
#include <malloc.h>
typedef struct treeNode *PTREENODE;
typedef struct treeNode {
	int data;
	PTREENODE leftChild;
	PTREENODE rightChild;
} TREENODE;

PTREENODE createNode(int data);
PTREENODE findPositionInBST(PTREENODE ptr, int key);
void insertInBST(PTREENODE *ptrHead, int key);
void visitTreeInOrder(PTREENODE ptr);

int main()
{
	PTREENODE ptrHead = NULL, ptr;

	insertInBST(&ptrHead, 20);
	insertInBST(&ptrHead, 30);
	insertInBST(&ptrHead, 10);
	insertInBST(&ptrHead, 15);

	ptr = ptrHead;
	visitTreeInOrder(ptr);
	return 0;
}

void insertInBST(PTREENODE *head, int key)
{
	PTREENODE ptr;
	PTREENODE tmp;

	/*   */
	ptr = createNode(key);
	if (*head == NULL)
	{
		*head = ptr;
		return;
	}
	else
	{ /* ptr  ġ ã */
		tmp = findPositionInBST(*head, key);
		if (tmp == NULL)
			return; /* BST Ű  ִ  */
		if (key < tmp->data)
			tmp->leftChild = ptr;
		else
			tmp->rightChild = ptr;
	}
}

PTREENODE findPositionInBST(PTREENODE ptr, int key)
{
	if (key == ptr->data)
		return NULL;
	else if (key < ptr->data)
	{
		if (ptr->leftChild == NULL)
			return ptr;
		else
			return findPositionInBST(ptr->leftChild, key);
	}
	else
	{
		if (ptr->rightChild == NULL)
			return ptr;
		else
			return findPositionInBST(ptr->rightChild, key);
	}
}

PTREENODE createNode(int data)
{
	PTREENODE ptr;
	ptr = (PTREENODE) malloc(sizeof(TREENODE));
	ptr->data = data;
	ptr->leftChild = NULL;
	ptr->rightChild = NULL;
	return ptr;
}

void visitTreeInOrder(PTREENODE ptr)
{ /*  ȸ: (left, root, right) */
	if (ptr != NULL)
	{
		visitTreeInOrder(ptr->leftChild);
		printf("%d ", ptr->data);
		visitTreeInOrder(ptr->rightChild);
	}
}
