#include <stdio.h>
#include <string.h>
#include <malloc.h>
#define MAXSIZE   5
typedef struct treeNode *PTREENODE;
typedef struct treeNode {
	char name[20];
	int score;
	PTREENODE leftChild;
	PTREENODE rightChild;
} TREENODE;

void insertInBST(PTREENODE *head, char name[], int score);
PTREENODE findPositionInBST(PTREENODE ptr, char name[]);
PTREENODE createNode(char name[], int score);
void visitTreeInOrder(PTREENODE ptr);
PTREENODE searchInBST(PTREENODE ptr, char name[]);

int main()
{
	char name[MAXSIZE][20] = { "̿", "ö", "ȫ浿", "տ", "ڹμ" };
	int score[MAXSIZE] = { 80, 90, 60, 50, 70 };

	PTREENODE ptrHead = NULL, ptr, tmpPtr;
	char key[20] = "տ";

	int i;
	for (i = 0; i < MAXSIZE; i++)
		insertInBST(&ptrHead, name[i], score[i]);

	/* BST ִ  带  ȸ */
	visitTreeInOrder(ptrHead);

	ptr = ptrHead;
	tmpPtr = searchInBST(ptr, key);

	if (tmpPtr == NULL)
		printf("\n%s ڷ ϴ.", key);
	else
		printf("\n%s  %dԴϴ.", tmpPtr->name, tmpPtr->score);
	return 0;
}

PTREENODE searchInBST(PTREENODE ptr, char name[])
{
	if (strcmp(name, ptr->name) == 0)
		return ptr;
	else if (strcmp(name, ptr->name) < 0)
	{
		/* printf("name = %s\n", ptr->name); */
		if (ptr->leftChild == NULL)
			return NULL;
		else
			return searchInBST(ptr->leftChild, name);
	}
	else
	{
		/* printf("name = %s\n", ptr->name); */
		if (ptr->rightChild == NULL)
			return NULL;
		else
			return searchInBST(ptr->rightChild, name);
	}
}

void insertInBST(PTREENODE *head, char name[], int score)
{
	PTREENODE ptr;
	PTREENODE tmp;
	/*    */
	ptr = createNode(name, score);
	if (*head == NULL)
	{
		*head = ptr;
		return;
	}
	else
	{ /* ptr  ġ ã */
		tmp = findPositionInBST(*head, name);
		if (tmp == NULL)
			return; /* BST Ű  ִ  */
		if (strcmp(name, tmp->name) < 0)
			tmp->leftChild = ptr;
		else
			tmp->rightChild = ptr;
	}
}

PTREENODE findPositionInBST(PTREENODE ptr, char name[])
{
	if (strcmp(name, ptr->name) == 0)
		return NULL;
	else if (strcmp(name, ptr->name) < 0)
	{
		if (ptr->leftChild == NULL)
			return ptr;
		else
			return findPositionInBST(ptr->leftChild, name);
	}
	else
	{
		if (ptr->rightChild == NULL)
			return ptr;
		else
			return findPositionInBST(ptr->rightChild, name);
	}
}

PTREENODE createNode(char name[], int score)
{
	PTREENODE ptr;
	ptr = (PTREENODE) malloc(sizeof(TREENODE));
/*	strcpy(ptr->name, name); */
	strcpy_s(ptr->name, sizeof(ptr->name), name);
	ptr->score = score;
	ptr->leftChild = NULL;
	ptr->rightChild = NULL;
	return ptr;
}

void visitTreeInOrder(PTREENODE ptr)
{ /*  ȸ: (left, root, right) */
	if (ptr != NULL)
	{
		visitTreeInOrder(ptr->leftChild);
		printf("%s : %d\n", ptr->name, ptr->score);
		visitTreeInOrder(ptr->rightChild);
	}
}
