#include <stdio.h>
#include <stdlib.h>
#include <string.h>
typedef struct score {
	char name[20];
	int kor;
	int eng;
	int math;
	int sum;
	float average;
} SCORE;

void mergeDataFile(char *strIn1, char *strIn2, char *strOut);
FILE *fileOpen(char *strFileName, char *strMode);
int readOneDataInFile(FILE *fp, SCORE *pStudent);
void writeOneDataToFile(FILE *fp, SCORE pStudent);
void writeAllDataToFile(FILE *fp, FILE *fpOut);

int main()
{
	mergeDataFile("result1.txt", "result2.txt", "mergeResult.txt");
	return 0;
}

void mergeDataFile(char *strIn1, char *strIn2, char *strOut)
{
	FILE *fpIn1, *fpIn2, *fpOut;
	SCORE student1; // fpIn1 д  
	SCORE student2; // fpIn2 д  
	int nFileState1;
	int nFileState2;

	fpIn1 = fileOpen(strIn1, "r");
	fpIn2 = fileOpen(strIn2, "r");
	fpOut = fileOpen(strOut, "w");

	nFileState1 = readOneDataInFile(fpIn1, &student1); // fpIn1 1 ͸ 
	nFileState2 = readOneDataInFile(fpIn2, &student2); // fpIn2 1 ͸ 
	while (nFileState1 == 1 || nFileState2 == 1)
	{
		if (nFileState1 == EOF) /* student2 Ͱ ִ  */
		{
			writeOneDataToFile(fpOut, student2); /* ̹    */
			writeAllDataToFile(fpIn2, fpOut); /*  ͸ о  */
			break;
		}
		else if (nFileState2 == EOF) /* student1 Ͱ ִ  */
		{
			writeOneDataToFile(fpOut, student1); /* ̹    */
			writeAllDataToFile(fpIn1, fpOut); /*  ͸ о  */
			break;
		}
		else /* Է  2 ͸   */
		{
			if (strcmp(student1.name, student2.name) <= 0)
			{
				writeOneDataToFile(fpOut, student1);
				nFileState1 = readOneDataInFile(fpIn1, &student1);
			}
			else
			{
				writeOneDataToFile(fpOut, student2);
				nFileState2 = readOneDataInFile(fpIn2, &student2);
			}

		}
	} /* while   */
	fclose(fpIn1);
	fclose(fpIn2);
	fclose(fpOut);
}
FILE * fileOpen(char *strFileName, char *strMode)
{
	FILE *fp;
/*	if ((fp = fopen(strFileName, strMode)) == NULL) */
	fopen_s(&fp, strFileName, strMode);
	if(fp == NULL)
	{
		printf("(%s)   ϴ.\n", strFileName);
		exit(1);
	}
	return fp;
}

int readOneDataInFile(FILE *fp, SCORE *pStudent)
{
	char name[20];
	int k, e, m;
	int sum;
	float avg;
/*	if (fscanf(fp, "%s %d %d %d %d %f", name, &k, &e, &m, &sum, &avg) != EOF) */
	if (fscanf_s(fp, "%s %d %d %d %d %f", name, sizeof(name), &k, &e, &m, &sum, &avg) != EOF)
	{
	/*	strcpy(pStudent->name, name); */
		strcpy_s(pStudent->name, sizeof(pStudent->name), name);
		pStudent->kor = k;
		pStudent->eng = e;
		pStudent->math = m;
		pStudent->sum = sum;
		pStudent->average = avg;
		return 1; //  ͸ 
	}
	else
	{
		// fclose(fp);
		return EOF; //  (EOF = -1)
	}
}

void writeOneDataToFile(FILE *fp, SCORE student)
{
	fprintf(fp, "%6s %4d %4d %4d %4d %10.6f\n", student.name, student.kor,
		student.eng, student.math, student.sum, student.average);
}

void writeAllDataToFile(FILE *fp, FILE *fpOut)
{
	char name[20];
	int k, e, m;
	int sum;
	float avg;
/*	while (fscanf(fp, "%s %d %d %d %d %f", name, &k, &e, &m, &sum, &avg) != EOF) */
	while (fscanf_s(fp, "%s %d %d %d %d %f", name, sizeof(name), &k, &e, &m, &sum, &avg) != EOF)
	{
		fprintf(fp, "%6s %4d %4d %4d %4d %10.6f\n", name, k, e, m, sum, avg);
	}
}
