#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
typedef unsigned char BYTE;  /* 1Ʈ */
typedef unsigned short WORD; /* 2Ʈ */
typedef unsigned long DWORD; /* 4Ʈ */

#define RGB(r, g ,b)  ((DWORD) (((BYTE)(r) | \
    ((WORD) (g) << 8)) | \
    (((DWORD) (BYTE) (b)) << 16)))

/* Ǻ  */
#if ( _MSC_VER >= 800 )
/*#include <pshpack2.h> */
#pragma pack(push, 2)

#endif

typedef struct tagBITMAPFILEHEADER
{
	WORD bfType;      /* 0x4D42="BM"                   */
	DWORD bfSize;     /*  Ʈ ũ            */
	WORD bfReserved1; /* ׻ 0                        */
	WORD bfReserved2; /* ׻ 0                        */
	DWORD bfOffBits;  /* Ʈ   Ʈ */
} BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER
{ /* bmih */
	DWORD biSize;          /* sizeof(BITMAPINFOHEADER) = 40Ʈ */
	DWORD biWidth;         /* ȼ   ũ */
	DWORD biHeight;        /* ȼ   ũ */
	WORD biPlanes;         /* ׻  1             */
	WORD biBitCount;       /* ȼ Ʈ (1, 4, 8, 16, 24, 32)    */
	DWORD bibiCompression; /* : 0(  ),1(RLE-8), 2(RLE-4) */
	DWORD biSizeImage;     /* Ʈ Ʈ ũ  */
	DWORD biXPelsPerMeter; /* ʹ  ȭ ũ */
	DWORD biYPelsPerMeter; /* ʹ  ȭ    */
	DWORD biClrUsed;       /*           */
	DWORD biClrImportant;  /* ߿          */
} BITMAPINFOHEADER;

typedef struct tagRGBQUAD
{
	BYTE rgbRed;   /* Red   */
	BYTE rgbGreen; /* Green */
	BYTE rgbBlue;  /* Blue  */
	BYTE rgbReserved;
} RGBQUAD;

#if ( _MSC_VER >= 800 )
/*#include <poppack.h> */
#pragma pack(pop)
#endif

void BmpFileWrite(char fileName[], BYTE *pDIB);
BYTE *CreateDibImg(int nWidth, int nHeight, int nBitCount);
void BmpFillColor(BYTE *pDIB, DWORD color);

int main()
{
	BYTE *pDIB = NULL;

	pDIB = CreateDibImg(640, 480, 8);
	BmpFillColor(pDIB, 255); /* White */
/*	
	pDIB = CreateDibImg(640, 480, 24);
	BmpFillColor(pDIB, RGB(255,255, 0) );
*/	
	BmpFileWrite("test.bmp", pDIB);
	return 0;
}

BYTE *CreateDibImg(int nWidth, int nHeight, int nBitCount)
{
	BITMAPINFOHEADER bmIH;
	RGBQUAD *pRGB = NULL;
	BYTE *pDIB;
	int nColor = 0;
	int i;
	bmIH.biSize = sizeof(BITMAPINFOHEADER);
	bmIH.biWidth = nWidth;
	bmIH.biHeight = nHeight;
	bmIH.biPlanes = 1;
	bmIH.biBitCount = nBitCount;
	bmIH.bibiCompression = 0;
	bmIH.biSizeImage = (nWidth * nHeight) * (nBitCount / 8);
	bmIH.biClrUsed = 0;
	bmIH.biClrImportant = 0;
	if (bmIH.biBitCount == 8)
	{
		nColor = (1 << bmIH.biBitCount);
		pRGB = (RGBQUAD*) malloc(nColor * sizeof(RGBQUAD));
		for (i = 0; i < nColor; i++) /* ׷̽  ǥ */
		{
			pRGB[i].rgbRed = (BYTE) i;
			pRGB[i].rgbGreen = (BYTE) i;
			pRGB[i].rgbBlue = (BYTE) i;
			pRGB[i].rgbReserved = 0;
		}
	}
	if (pRGB != NULL)
		pDIB = (BYTE *) malloc(bmIH.biSize + nColor * sizeof(RGBQUAD)
				+ bmIH.biSizeImage);
	else
		pDIB = (BYTE *) malloc(bmIH.biSize + bmIH.biSizeImage);

	memcpy(pDIB, &bmIH, bmIH.biSize);
	if (pRGB != NULL)
	{
		memcpy(pDIB + bmIH.biSize, pRGB, nColor * sizeof(RGBQUAD));
		free(pRGB);
	}
	/* White ʱȭ */
	memset(pDIB + bmIH.biSize + nColor * sizeof(RGBQUAD), 255, bmIH.biSizeImage);
	return pDIB;
}

void BmpFillColor(BYTE *pDIB, DWORD color)
{
	BITMAPINFOHEADER *pbmIH;
	BYTE *pBitmap;
	int nColor, nColorSize = 0;
	unsigned int i;

	pbmIH = (BITMAPINFOHEADER *) pDIB;
	if (pbmIH->biBitCount == 8)
	{
		nColor = (1 << pbmIH->biBitCount);
		nColorSize = nColor * sizeof(RGBQUAD);
	}
	pBitmap = (BYTE *) (pDIB + 40 + nColorSize);

	/* ä  */
	for (i = 0; i < pbmIH->biSizeImage; i += pbmIH->biBitCount / 8)
	{
		if (pbmIH->biBitCount == 8)
			pBitmap[i] = (BYTE) (color);
		else // 24
		{
			pBitmap[i] = (BYTE) (color >> 16);
			pBitmap[i + 1] = (BYTE) (color >> 8);
			pBitmap[i + 2] = (BYTE) (color);
		}
	}
}

void BmpFileWrite(char fileName[], BYTE *pDIB)
{
	BITMAPFILEHEADER bmFH;
	BITMAPINFOHEADER *pbmIH;
	int nBitmapSize;
	int nColor, nColorSize = 0;
	FILE *fpW;
	pbmIH = (BITMAPINFOHEADER *) pDIB;
	nBitmapSize = pbmIH->biSizeImage;
	if (pbmIH->biBitCount == 8)
	{
		nColor = (1 << pbmIH->biBitCount);
		nColorSize = nColor * sizeof(RGBQUAD);
	}
	bmFH.bfType = 0x4D42; /* "BM" */
	bmFH.bfSize = 14 + 40 + nColorSize + nBitmapSize;
	bmFH.bfReserved1 = 0;
	bmFH.bfReserved2 = 0;
	bmFH.bfOffBits = 14 + 40 + nColorSize;

/*	fpW = fopen(fileName, "wb"); */
	fopen_s(&fpW, fileName, "wb");

	fwrite(&bmFH, sizeof(BITMAPFILEHEADER), 1, fpW);
	fwrite(pDIB, 40 + nColorSize + nBitmapSize, 1, fpW);
	fclose(fpW);
	free(pDIB);
}