#include<iostream>
#include<fstream>
#include <iomanip>
#include <windows.h>
using namespace std;
class CBmp
{
	BITMAPFILEHEADER m_bmFH;
	BITMAPINFOHEADER m_bmIH;
	RGBQUAD *m_pRGB;
	BYTE *m_pDIB;
public:
	CBmp();
	~CBmp();
	bool LoadBmp(char *strFileName);
	void DisplayBmpInfor();
};

CBmp::CBmp()
{
	m_pRGB = NULL;
	m_pDIB = NULL;
}

CBmp::~CBmp()
{
	if (m_pRGB)
		delete m_pRGB;
	if (m_pDIB)
		delete m_pDIB;
}

void CBmp::DisplayBmpInfor()
{
	cout << " Ʈ ũ = " << m_bmFH.bfSize << "\n";
	cout << " Ʈ =  " << m_bmFH.bfOffBits << "\n";

	cout << "m_bmIH.biSize = " << m_bmIH.biSize << "\n";
	cout << "m_bmIH.biWidth = " << m_bmIH.biWidth << "\n";
	cout << "m_bmIH.biHeight = " << m_bmIH.biHeight << "\n";
	cout << "m_bmIH.biPlanes = " << m_bmIH.biPlanes << "\n";
	cout << "m_bmIH.biBitCount = " << m_bmIH.biBitCount << "\n";
	cout << "m_bmIH.bibiCompression = " << m_bmIH.biCompression << "\n";
	cout << "m_bmIH.biSizeImage = " << m_bmIH.biSizeImage << "\n";
	cout << "m_bmIH.biClrUsed = " << m_bmIH.biClrUsed << "\n";
	cout << "m_bmIH.biClrImportant = " << m_bmIH.biClrImportant << "\n";

	if (m_pRGB)
	{
		int nColor;
		if (m_bmIH.biClrUsed == 0)
			nColor = (1 << m_bmIH.biBitCount);
		else
			nColor = m_bmIH.biClrUsed;

		unsigned r, g, b;
		cout << dec << "nColor = " << nColor << "\n";
		for (int i = 0; i < nColor; i++)
		{
			r = m_pRGB[i].rgbRed;
			g = m_pRGB[i].rgbGreen;
			b = m_pRGB[i].rgbBlue;
			cout << "RGB[" << setw(3) << i << "] = " << setw(3) << r << ", "
					<< setw(3) << g << ", " << setw(3) << b << "\n";
		}
	}
}

bool CBmp::LoadBmp(char *strFileName)
{
	int nColor;
	int nDibSize;

	//  
	ifstream inFile(strFileName, ios::in | ios::binary);
	//  Ʈ  (14Ʈ) 
	inFile.read((char *) &m_bmFH, sizeof(BITMAPFILEHEADER));
	// BMP  Ȯ
	if (m_bmFH.bfType != 0x4D42)
		return false;

	//  Ʈ (40Ʈ) 
	inFile.read((char*) &m_bmIH, sizeof(BITMAPINFOHEADER));
	if (m_bmIH.biBitCount < 16)
	{ // ε ÷(Indexed color)̸ ȷƮ ̺ 
		//    
		if (m_bmIH.biClrUsed == 0)
			nColor = (1 << m_bmIH.biBitCount);
		else
			nColor = m_bmIH.biClrUsed;
		// ȷƮ ̺ ޸𸮸 Ҵϰ 
		m_pRGB = new RGBQUAD[nColor];
		inFile.read((char*) m_pRGB, sizeof(RGBQUAD) * nColor);
	}
	//  Ʈ(raw bitmap)   Ʈ ϰ,
	// ޸𸮸 Ҵ  
	nDibSize = m_bmFH.bfSize - m_bmFH.bfOffBits;
	m_pDIB = new BYTE[nDibSize];
	inFile.read((char*)m_pDIB, nDibSize);
	inFile.close(); //  
	return true;
}
int main()
{
	CBmp bmp;
	if (bmp.LoadBmp("background.bmp"))
	{
		bmp.DisplayBmpInfor();
	}
	return 0;
}
