#include <iostream>
#include <list>
using namespace std;
class CPoint
{
	int x;
	int y;
public:
	CPoint(int x = 0, int y = 0); // 
	CPoint(const CPoint &); //  
	~CPoint() { cout << "Destructor\n"; };
	void SetPt(int x, int y);
	int GetX() { return x; }
	int GetY() { return y; }
	CPoint &operator=(const CPoint &pt);
	friend ostream & operator <<(ostream &out, CPoint &pt);
};

CPoint::CPoint(int x, int y) // 
{
	this->x = x;
	this->y = y;
}

CPoint::CPoint(const CPoint &pt) //  
{
	cout << "Copy constructor" << endl;
	x = pt.x;
	y = pt.y;
}

void CPoint::SetPt(int x, int y)
{
	this->x = x;
	this->y = y;
}

CPoint& CPoint::operator=(const CPoint &pt)
{
	this->x = pt.x;
	this->y = pt.y;
	return *this;
}

ostream & operator<<(ostream &out, CPoint & pt) //  Լ
{
	out << "(" << pt.x << ", " << pt.y << ") ";
	return out;
}

int main()
{
	list<CPoint> L;
	CPoint pt(10, 20);

	L.push_back(pt); //   ȣ

	pt.SetPt(10, 30);
	L.push_back(pt); //   ȣ

	pt.SetPt(10, 40);
	L.push_back(pt); //   ȣ

	list<CPoint>::iterator it;
	cout << "Using (*it).GetX(), (*it).GetY()" << endl;
	for (it = L.begin(); it != L.end(); it++)
		cout << "(" << (*it).GetX() << ", " << (*it).GetY() << ") ";
	cout << endl;

	cout << endl << "operator << friend function!" << endl;
	for (it = L.begin(); it != L.end(); it++)
		cout << *it << " "; //   << ȣ
	cout << endl;

	return 0;
}
